# class SlaveBase | There are two classes that specifies the protocol between application (job) and kioslave. More...
Full name | `KIO::SlaveBase`
Definition | `#include <slavebase.h>`
Inherited by | TCPSlaveBase
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum { QuestionYesNo = 1, WarningYesNo = 2, WarningContinueCancel = 3, WarningYesNoCancel = 4, Information = 5, SSLMessageBox = 6 }

#### Public Methods

- SlaveBase ( const QCString &protocol, const QCString &pool_socket, const QCString &app_socket)
- virtual ~SlaveBase ()
- void dispatchLoop ()
- void setConnection ( Connection* connection )
- Connection * connection () const
- void data ( const QByteArray &data )
- void dataReq ( )
- void error ( int _errid, const QString &_text )
- void connected ()
- void finished ()
- void needSubURLData ()
- void slaveStatus (const QString &host, bool connected)
- void statEntry ( const UDSEntry& _entry )
- void listEntries ( const UDSEntryList& _entry )
- bool canResume ( unsigned long offset )
- void canResume ()
- void totalSize ( unsigned long _bytes )
- void processedSize ( unsigned long _bytes )
- void speed ( unsigned long _bytes_per_second )
- void redirection ( const KURL &_url )
- void errorPage ()
- void mimeType ( const QString &_type )
- void gettingFile ( const QString &_file )
- void warning ( const QString &msg )
- void infoMessage ( const QString &msg )
- int messageBox ( int type, const QString &text, const QString &caption = QString::null, const QString &buttonYes = QString::null, const QString &buttonNo = QString::null )
- void setMetaData (const QString &key, const QString &value)
- QString metaData (const QString &key)
- virtual void setHost (const QString& host, int port, const QString& user, const QString& pass)
- virtual void setSubURL (const KURL&url)
- virtual void openConnection ()
- virtual void closeConnection ()
- virtual void get ( const KURL& url )
- virtual void put ( const KURL& url, int permissions, bool overwrite, bool resume )
- virtual void stat ( const KURL& url )
- virtual void mimetype ( const KURL& url )
- virtual void listDir ( const KURL& url )
- virtual void mkdir ( const KURL&url, int permissions )
- virtual void rename ( const KURL& src, const KURL& dest, bool overwrite )
- virtual void symlink ( const QString& target, const KURL& dest, bool overwrite )
- virtual void chmod ( const KURL& url, int permissions )
- virtual void copy ( const KURL &src, const KURL &dest, int permissions, bool overwrite )
- virtual void del ( const KURL &url, bool isfile)
- virtual void special ( const QByteArray & )
- virtual void slave_status ()
- virtual void reparseConfiguration ()
- virtual bool dispatch ()
- virtual void dispatch ( int command, const QByteArray &data )
- int readData ( QByteArray &buffer )

#### Public Static Methods

- static void sigsegv_handler (int)
- static void sigpipe_handler (int)

#### Protected Methods

- void listEntry ( const UDSEntry& _entry, bool ready)
- void connectSlave (const QString& path)
- void disconnectSlave ()
- bool pingCacheDaemon () const
- bool openPassDlg ( KIO::AuthInfo& info )
- bool openPassDlg ( const QString& msg, QString& user, QString& passwd, bool lock = false )
- bool checkCachedAuthentication ( AuthInfo& info )
- bool checkCachedAuthentication ( const KURL& url, QString& user, QString& passwd, QString& realm, QString& extra, bool verify = true )
- bool checkCachedAuthentication ( const KURL& url, QString& user, QString& passwd)
- bool cacheAuthentication ( const AuthInfo& info )
- bool cacheAuthentication ( const KURL& url, const QString& user, const QString& passwd, const QString& realm = QString::null, const QString& extra = QString::null )
- QString createAuthCacheKey ( const KURL& url )
- void sendAuthenticationKey ( const QCString&, const QCString&, bool )
- bool requestNetwork (const QString& host = QString::null)
- void dropNetwork (const QString& host = QString::null)
- int waitForAnswer ( int expected1, int expected2, QByteArray & data, int * pCmd = 0 )
- void sendMetaData ()
- void delCachedAuthentication ( const QString& )

#### Protected Members

- QCString mProtocol
- Connection * m_pConnection

## Detailed Description

There are two classes that specifies the protocol between application (job) and kioslave. SlaveInterface is the class to use on the application end, SlaveBase is the one to use on the slave end.

Slave implementations should simply inherit SlaveBase

A call to foo() results in a call to slotFoo() on the other end.

SlaveBase ( const QCString &protocol, const QCString &pool_socket, const QCString &app_socket) | ### SlaveBase

~SlaveBase () | ### ~SlaveBase

[virtual]

void dispatchLoop () | ### dispatchLoop

void setConnection ( Connection* connection ) | ### setConnection

Connection * connection () | ### connection

[const]

void data ( const QByteArray &data ) | ### data

Call to send data in the slave (i.e. in get).

Parameters:

data | the data read by the slave Send an empty QByteArray() to signal end of data.

void dataReq ( ) | ### dataReq

Call to ask for data (in put)

See also: readData

void error ( int _errid, const QString &_text ) | ### error

Call to signal an error. This also finishes the job, no need to call finished.

void connected () | ### connected

Call in openConnection, if you reimplement it, when you're done. Currently unused.

void finished () | ### finished

Call to signal successful completion of any command (besides openConnection and closeConnection)

void needSubURLData () | ### needSubURLData

Call to signal that data from the sub-URL is needed

void slaveStatus (const QString &host, bool connected) | ### slaveStatus

Used to report the status of the slave.

Parameters:

host | the slave is currently connected to. (Should be empty if not connected)
connected | Whether an actual network connection exists.

void statEntry ( const UDSEntry& _entry ) | ### statEntry

Call this from stat() to express details about an object, the UDSEntry customarily contains the atoms describing file name, size, mimetype, etc.

Parameters:

_entry | The UDSEntry containing all of the object attributes.

void listEntries ( const UDSEntryList& _entry ) | ### listEntries

Call this in listDir, each time you have a bunch of entries to report.

bool canResume ( unsigned long offset ) | ### canResume

Call this at the beginning of put(), to give the size of the existing partial file, if there is one. The `offset` argument notifies the other job (the one that gets the data) about the offset to use. In this case, the boolean returns whether we can indeed resume or not (we can't if the protocol doing the get() doesn't support setting an offset)

void canResume () | ### canResume

void totalSize ( unsigned long _bytes ) | ### totalSize

Call this in get and copy, to give the total size of the file Call in listDir too, when you know the total number of items.

void processedSize ( unsigned long _bytes ) | ### processedSize

Call this during get and copy, once in a while, to give some info about the current state. Don't emit it in listDir, listEntries speaks for itself.

void speed ( unsigned long _bytes_per_second ) | ### speed

Call this in get and copy, to give the current transfer speed. Usually worked out as processed_size / ( t - t_start )

void redirection ( const KURL &_url ) | ### redirection

Call this to signal a redirection The job will take care of going to that url.

void errorPage () | ### errorPage

Tell that we will only get an error page here. This means: the data you'll get isn't the data you requested, but an error page (usually HTML) that describes an error.

void mimeType ( const QString &_type ) | ### mimeType

Call this in mimetype, when you know the mimetype. See mimetype about other ways to implement it.

void gettingFile ( const QString &_file ) | ### gettingFile

void warning ( const QString &msg ) | ### warning

Call to signal a warning, to be displayed in a dialog box.

void infoMessage ( const QString &msg ) | ### infoMessage

Call to signal a message, to be displayed if the application wants to, for instance in a status bar. Usual examples are "connecting to host xyz", etc.

enum { QuestionYesNo = 1, WarningYesNo = 2, WarningContinueCancel = 3, WarningYesNoCancel = 4, Information = 5, SSLMessageBox = 6 } | ###

int messageBox ( int type, const QString &text, const QString &caption = QString::null, const QString &buttonYes = QString::null, const QString &buttonNo = QString::null ) | ### messageBox

Call this to show a message box from the slave (it will in fact be handled by kio_uiserver, so that the progress info dialog for the slave is hidden while this message box is shown)

Parameters:

type | type of message box: QuestionYesNo, WarningYesNo, WarningContinueCancel...
text | Message string. May contain newlines.
caption | Message box title.
buttonYes | The text for the first button. The default is i18n("&Yes").
buttonNo | The text for the second button. The default is i18n("&No"). Note: for ContinueCancel, buttonYes is the continue button and buttonNo is unused. and for Information, none is used.

Returns: a button code, as defined in KMessageBox, or 0 on communication error.

void setMetaData (const QString &key, const QString &value) | ### setMetaData

Sets meta-data to be send to the application before the first data() or finished() signal.

QString metaData (const QString &key) | ### metaData

Queries for meta-data send by the application to the slave.

void setHost (const QString& host, int port, const QString& user, const QString& pass) | ### setHost

[virtual]

Set the host

This method is called whenever a change in host, port or user occurs.

Parameters:

pass | Called directly by createSlave, this is why there is no equivalent in SlaveInterface, unlike the other methods.

void setSubURL (const KURL&url) | ### setSubURL

[virtual]

Prepare slave for streaming operation

void openConnection () | ### openConnection

[virtual]

Opens the connection (forced) Currently unused.

void closeConnection () | ### closeConnection

[virtual]

Closes the connection (forced) Called when the application disconnects the slave to close any open network connections.

void get ( const KURL& url ) | ### get

[virtual]

get, aka read.

Parameters:

url | the full url for this request. Host, port and user of the URL can be assumed to be the same as in the last setHost() call. The slave emits the data through data

void put ( const KURL& url, int permissions, bool overwrite, bool resume ) | ### put

[virtual]

put, aka write.

Parameters:

path | where to write the file (decoded)
permissions | may be -1. In this case no special permission mode is set.
overwrite | if true, any existing file will be overwritten. If the file indeed already exists, the slave should NOT apply the permissions change to it.
resume |

void stat ( const KURL& url ) | ### stat

[virtual]

Finds all details for one file or directory. The information returned is the same as what listDir returns, but only for one file or directory.

void mimetype ( const KURL& url ) | ### mimetype

[virtual]

Finds mimetype for one file or directory.

This method should either emit 'mimeType' or it should send a block of data big enough to be able to determine the mimetype.

If the slave doesn't reimplement it, a get will be issued, i.e. the whole file will be downloaded before determining the mimetype on it - this is obviously not a good thing in most cases.

void listDir ( const KURL& url ) | ### listDir

[virtual]

Lists the contents of `path`. The slave should emit ERR_CANNOT_ENTER_DIRECTORY if it doesn't exist, if we don't have enough permissions, or if it is a file It should also emit totalFiles as soon as it knows how many files it will list.

void mkdir ( const KURL&url, int permissions ) | ### mkdir

[virtual]

Create a directory

Parameters:

path | path to the directory to create
permissions | the permissions to set after creating the directory (-1 if no permissions to be set) The slave emits ERR_COULD_NOT_MKDIR if failure.

void rename ( const KURL& src, const KURL& dest, bool overwrite ) | ### rename

[virtual]

Rename `oldname` into `newname`. If the slave returns an error ERR_UNSUPPORTED_ACTION, the job will ask for copy + del instead.

Parameters:

src | where to move the file from
dest | where to move the file to
overwrite | if true, any existing file will be overwritten

void symlink ( const QString& target, const KURL& dest, bool overwrite ) | ### symlink

[virtual]

Creates a symbolic link named `dest`, pointing to `target`, which may be a relative or an absolute path.

Parameters:

target | The string that will become the "target" of the link (can be relative)
dest | The symlink to create.
overwrite | whether to automatically overwrite if the dest exists

void chmod ( const KURL& url, int permissions ) | ### chmod

[virtual]

Change permissions on `path` The slave emits ERR_DOES_NOT_EXIST or ERR_CANNOT_CHMOD

void copy ( const KURL &src, const KURL &dest, int permissions, bool overwrite ) | ### copy

[virtual]

Copy `src` into `dest`. If the slave returns an error ERR_UNSUPPORTED_ACTION, the job will ask for get + put instead.

Parameters:

src | where to copy the file from (decoded)
dest | where to copy the file to (decoded)
permissions | may be -1. In this case no special permission mode is set.
overwrite | if true, any existing file will be overwritten

void del ( const KURL &url, bool isfile) | ### del

[virtual]

Delete a file or directory.

Parameters:

path | file/directory to delete
isfile | if true, a file should be deleted. if false, a directory should be deleted.

void special ( const QByteArray & ) | ### special

[virtual]

Used for any command that is specific to this slave (protocol) Examples are : HTTP POST, mount and unmount (kio_file)

Parameters:

data | packed data; the meaning is completely dependent on the slave, but usually starts with an int for the command number. Document your slave's commands, at least in its header file.

void slave_status () | ### slave_status

[virtual]

Called to get the status of the slave. Slave should respond by calling slaveStatus(...)

void reparseConfiguration () | ### reparseConfiguration

[virtual]

Called by the scheduler to tell the slave that the configuration changed (i.e. proxy settings) .

void sigsegv_handler (int) | ### sigsegv_handler

[static]

void sigpipe_handler (int) | ### sigpipe_handler

[static]

bool dispatch () | ### dispatch

[virtual]

void dispatch ( int command, const QByteArray &data ) | ### dispatch

[virtual]

int readData ( QByteArray &buffer ) | ### readData

Read data send by the job, after a dataReq

Parameters:

buffer | buffer where data is stored

Returns: 0 on end of data, > 0 bytes read < 0 error

void listEntry ( const UDSEntry& _entry, bool ready) | ### listEntry

[protected]

internal function to be called by the slave. It collects entries and emits them via listEntries when enough of them are there or a certain time frame exceeded (to make sure the app gets some items in time but not too many items one by one as this will cause a drastic performance penalty)

Parameters:

ready | set to true after emitting all items. _entry is not used in this case

void connectSlave (const QString& path) | ### connectSlave

[protected]

internal function to connect a slave to/ disconnect from either the slave pool or the application

void disconnectSlave () | ### disconnectSlave

[protected]

bool pingCacheDaemon () | ### pingCacheDaemon

[protected const]

Checks whether the password daemon kdesud is running or if it can be started if it is not.

Returns: true if password daemon is/can be started successfully.

bool openPassDlg ( KIO::AuthInfo& info ) | ### openPassDlg

[protected]

Prompt the user for Authrization info (login & password).

Use this function to request authorization info from the the end user. For example to open an empty password dialog using default values:

     KIO::AuthInfo authInfo;
     bool result = openPassDlg( authInfo );
     if ( result )
     {
        printf( "Username: %s", result.username.latin1() );
        printf( "Username: %s", result.username.latin1() );
     }

You can also pre-set some values like the username before hand if it is known as well as the comment and caption to be displayed:

     authInfo.comment= "Enter username and password to access acmeone";
     authInfo.caption= "Acme Password Dialog";
     authInfo.username= "Wily E. kaiody";
     bool result = openPassDlg( authInfo );
     if ( result )
     {
        printf( "Username: %s", result.username.latin1() );
        printf( "Username: %s", result.username.latin1() );
     }

NOTE: A call to this function can also fail and result in a return value of `false`, if the UIServer could not be started for whatever reason.

Parameters:

See | AuthInfo.

Returns: `TRUE` if user clicks on "OK", `FALSE` otherwsie.

bool openPassDlg ( const QString& msg, QString& user, QString& passwd, bool lock = false ) | ### openPassDlg

[protected]

Same as above except in the arguments it accepts.

Parameters:

msg | i18n'ed message to explain the dialog box
user | user name, in and out
pass | password, in and out
lock | flag used to make the username field read-only.

bool checkCachedAuthentication ( AuthInfo& info ) | ### checkCachedAuthentication

[protected]

Checks for cached authentication based on paramters given by `info`.

Use this function to check if any cached password exists for the `URL` given by `info`. If `AuthInfo::realValue` is present and/or the `AuthInfo::verifyPath` flag is set, then they will also be factored in determining the presence of a cached password. Note that `Auth::url` is a required parameter when attempting to check for cached authorization info. Here is a simple example:

     AuthInfo info;
     info.url = KURL("http://www.foobar.org/foo/bar");
     bool result = openPassDlg( info );

If the protocol allows multiple resources within the same location to be protected by different passwords, then to determine the correct password and still be able to send the correct password pre-emtively, i.e. before the other end requires it, you can use one or both of the following methods: set the unique identifier using `AuthInfo::realValue` or require that a path match be performed using `AuthInfo::verifyPath`.

     info.url = KURL("http://www.foobar.org/foo/bar");
     info.verifyPath = true;
     info.realmValue = "unique_identifier";

NOTE: A call to this function can also fail and result in a return value of `false`, if "kdesud" could not be started for whatever reason or if no URL was supplied.

Parameters:

See | AuthInfo.

Returns: `TRUE` if cached Authorization is found, false otherwise.

bool checkCachedAuthentication ( const KURL& url, QString& user, QString& passwd, QString& realm, QString& extra, bool verify = true ) | ### checkCachedAuthentication

[protected]

Same as above except in the number of arguments it accepts.

Parameters:

url | url for which to check cached Authentication.
user | cached user name.
passw | cached password.
realm | unique key to distinguish protection spaces (ex: HTTP Realm values)
extra | extra info to store (ex: Authentication strings in Digest Authentication )
verify | if true, check new url contains cached url (== same protection space)

bool checkCachedAuthentication ( const KURL& url, QString& user, QString& passwd) | ### checkCachedAuthentication

[protected]

Same as above except in the number of arguments it takes.

Parameters:

url | url for which to check cached Authentication.
user | cached user name.
passw | cached password.

bool cacheAuthentication ( const AuthInfo& info ) | ### cacheAuthentication

[protected]

Caches authentication information in "kdesud".

Use this function to cache correct authorization information so that you will not have to request it again from the end user. By default is automatically deleted if the application that cached it is shutdown properly. You can change this by setting the @AuthInfo::keepPassword flag so that the password is cached for the duration of the current KDE session or the end-user manually does "kdesu -s" to stop the running "kdesud" process. Additionally, this function does not check whether the provided authorization info is already cached and will simply overwrite it.

NOTE: A call to this function can also fail and result in a return value of `false`, if "kdesud" could not be started for whatever reason or when no URL was supplied. Additionally, if application that cached the password crashes, the password will be kept for the duration of the current KDE session.

Parameters:

See | AuthInfo.

Returns: `TRUE` if the authorization info was sucessfully cached.

bool cacheAuthentication ( const KURL& url, const QString& user, const QString& passwd, const QString& realm = QString::null, const QString& extra = QString::null ) | ### cacheAuthentication

[protected]

Same as above except in the number of arguments it takes.

Parameters:

url | url for which Authentication is to be cached.
user | user name to be cached.
passw | password to be cached.
realm | unique key to distinguish protection spaces (ex: HTTP Realm values)
extra | extra info to store (ex: Authentication strings in Digest Authentication )

Returns: `true` if Authentication was sucessfully cached

QString createAuthCacheKey ( const KURL& url ) | ### createAuthCacheKey

[protected]

Creates a basic key to be used to cache the password.

void sendAuthenticationKey ( const QCString&, const QCString&, bool ) | ### sendAuthenticationKey

[protected]

Sends the authentication key to the application.

bool requestNetwork (const QString& host = QString::null) | ### requestNetwork

[protected]

Used by the slave to check if it can connect to a given host. This should be called where the slave is ready to do a ::connect() on a socket. For each call to requestNetwork must exist a matching call to dropNetwork, or the system will stay online until KNetMgr gets closed (or the SlaveBase gets destructed)!

If KNetMgr is not running, then this is a no-op and returns true

Parameters:

host | tells the netmgr the host the slave wants to connect to. As this could also be a proxy, we can't just take the host currenctly connected to (but that's the default value)

Returns: true in theorie, the host is reachable false the system is offline and the host is in a remote network.

void dropNetwork (const QString& host = QString::null) | ### dropNetwork

[protected]

Used by the slave to withdraw a connection requested by requestNetwork. This function cancels the last call to requestNetwork. If a client uses more than one internet connection, it must use dropNetwork(host) to stop each request.

If KNetMgr is not running, then this is a no-op.

A slave should call this function every time it disconnect from a host.

Parameters:

host | the host passed to requestNetwork

int waitForAnswer ( int expected1, int expected2, QByteArray & data, int * pCmd = 0 ) | ### waitForAnswer

[protected]

Wait for an answer to our request, until we get `expected1` or `expected2`

Returns: the result from readData, as well as the cmd in *pCmd if set, and the data in `data`

void sendMetaData () | ### sendMetaData

[protected]

Internal function to transmit meta data to the application.

void delCachedAuthentication ( const QString& ) | ### delCachedAuthentication

[protected]

QCString mProtocol | ### mProtocol

[protected]

Connection * m_pConnection | ### m_pConnection

[protected]

Generated by: root@i386.ports.openbsd.org on Wed Apr 25 13:58:36 2001, using kdoc 2.0a53.